               JOB  Fortran compiler -- phase 1 -- Read the Param card     00104
               CTL  6611
     *
     * Load this block and the next one
     *
     phas1     ldph Loader,begin1,loadnx,,,1.1
               xfr  phas1
     *
     * Read and Process the parameter card.
     *
     * Read and store the source program, in reverse order, starting
     * at the top of core, with blanks removed except within
     * Hollerith fields in FORMAT statements.  Each statement begins
     * with 000.  Format statements then have F, while others have R.
     * Then the label, if any, followed by a colon.  The end of each
     * statement is marked by a group mark with a word mark.  After
     * the last card, a STOP statement is inserted.
     *
   89X1        equ  089
   94X2        equ  094
   99X3        equ  099
     *
     * Addresses in Phase 0
     *
     nstmts    equ  183  Number of statements, including generated stop
     *
               ext00  Snapsh, Loadnx, CDovly
     *
     * Storage for parameter card is in phase 0
     *
  685pword     equ  685     The word PARAM
  688topcor    equ  688     Top core address from PARAM card
  690imod      equ  690     Integer modulus -- number of digits
  692mantis    equ  692     Floating point mantissa digits
  693condns    equ  693     P for condensed deck
  694snapsw    equ  694     S for snapshot
  695c1410     equ  695     T if run on 1410 in 1401 compatibility mode
  696fmtsw     equ  696     X for no format, L for limited format
     *                      blank for ordinary, A for A conversion
  699param     equ  699     Parameter card is stored here
     *
     * Read and check parameter card
     *
               org  872        Four less than Mokotoff v3m0 line 218
     begin1    cs   80         Clear Autocoder tape loader
               sw   1
               sw   81,84
  874          sw   gm         Originally done in phase 0
  876          R               Read parameter card
  877          LCA  19,param   Save it
  884          C    param-14,kparam  Is it a parameter card?
  891          BU   noparm     No, announce error
  896          SW   73         Set word marks for
  900          SW   6,7          Fortran margins
  907          SW   topcor-2
  911          MCW  80,pword
     *
     * Determine this machine's core size, compare it to
     * size on parameter card
     *
  918          CS   0-0
  922          SBR  corsiz
  926          MCW  topcor,toconv
  933          B    adconv     Covert topcor to five digits
  937          MCW  convtd,top5
  944          MCW  corsiz,toconv
  951          B    adconv     Convert corsiz to five digits
  955          MCW  convtd,cor5
  962          A    kp1,top5   Top addr + 1 = size
  969          A    kp1,cor5   Cor addr + 1 = size
  976          CS   332
  980          CS
  981          CC   1
  983          CS   332
  987          CS
  988          MCW  stmsg,228  Start Fortran Compilation msg
  995          W
  996          CC   J
  998          MCW  top5,231
 1005          MCW  spsize     Specified size
 1009          W
 1010          CS   235
 1014          MCW  cor5,228
 1021          MCW  actsiz     Actual size
 1025          BCE  bignuf,c1410,T  Compiling for 1410 compatibility?
 1033          W
 1034          C    cor5,top5
 1041          BH   psgtm       Print Spec size gt Mach size
 1046          C    top5,k3900  Compare top to 3900
 1053          BL   bignuf
 1058          CC   J
 1060          CS   332
 1064          CS
 1065          MCW  sizerr,218  Machine size error
 1072          W
 1073          B    useact
 1077psgtm     MCW  sgtm,267  Spec. size gt Mach. size msg
 1084          MCW  sgtm2     Rest of the message
 1088          W
 1089useact    MCW  corsiz,topcor  Use actual size
 1096bignuf    MCW  topcor,cleard&3
     *
     * Clear from top of this machine's memory down to DOWNTO
     *
 1103cleard    CS   0-0
 1107          SBR  cleard&3
 1111          C    cleard&3,downto
 1118          BU   cleard
               JOB  Fortran compiler -- phase 2 -- Read the Program        00204
     *
     * Read the program into core.
     *
 1123          R
 1124          MZ   *-6,azone  Set A zone after card storage area
 1131          MZ   *-6,intrst&7   Set A zone in BCE D-modifier
 1138          MZ   *-6,blnkok&7     ,,
 1145          MZ   *-6,intchr-1   Add A zone to interesting chars
 1152          MCW  prefix,card1-1  Set default prefix
 1159          MCW  topcor,*&4
 1166          CW   0-0
 1170          SBR  mvchar&6
     *
     * Process next card
     *
 1174rdloop    BW   movecd,flag
 1182          BCE  done,1,:
     *
     * No system after end card
     *
 1190nosys     CC   1
 1192          CS   332
 1196          CS
 1197          MCW  msg1,270
 1204          W
 1205          CC   1
 1207halt1     H    halt1
     *
     * Move card to save area                 
     *
 1211movecd    MCW  72,card72  Move card to save area
 1218          MCW
 1219          MCW
 1220          BCE  done,card1,:
 1228c12t      BIN  prthdg,  Unconditional at first, becomes BCV
 1233afthdg    CS   300
 1237          CS
 1238          MCW  72,283   Move card to print area
 1245          MCW  6,215
 1252          BCE  lstcmt,card1,C    Print now if comment
 1260crd1sw    B    notcnt  Becomes NOP after first card
 1264          BCE  notcnt,card6,0
 1272          BCE  notcnt,card6,
     *
     * Continuation card
     *
 1280          A    kp1,cntcnt        Bump continuation count
 1287          BCE  cntok,cntcnt-1,0  Nine or fewer?
 1295          MCW  cntmsg,300        Put error msg in print area
 1302cntok     W               List the card
 1303          MCW  card7a,svchar&3   Set save char addr to col 7
     *
     * Process the card (NOTCNT comes back here)
     *
 1310svchar    MCW  0-0,char          Save a character
 1317          SW   svchar&1
 1321          A    k1,svchar&3       Bump addr of char to save
 1328          CW   svchar&1
 1332crd2sw    NOP  blnkok            Branch if copying everything
 1336          BCE  svchar,char,      Skip blanks
 1344          MCW  char,*&8
 1351          BCE  intrst,intchr,0
               chain5
 1364mvchar    MCW  char,0
 1371          SBR  mvchar&6
 1375bumpns    A    kp1,nchar        Bump character counter
 1382          C    mvchar&6,botcor  Core full of source code?
 1389          BE   bigsrc
 1394crd3sw    BCE  holler,char,H
 1402crd4sw    NOP  branch,crd3sw
     *
 1409test7     C    svchar&3,card7a  At column 7?
 1416crd5sw    BU   svchar
 1421          SW   mvchar&4
 1425crd6sw    MCW  mvchar&6,X2
 1432          CW   mvchar&4
 1436          MCW  nop2,crd6sw
 1443          MCW  nop2,crd5sw
 1450          A    k10,colcnt
 1457          BCE  col3,colcnt-1,5    Three columns done?
 1465          SW   flag
 1469          BWZ  svchar,colcnt-1,2  More than seven columns done?
 1477          MCW  brnch2,crd5sw
 1484          MCW  0&X2,work7
 1491          C    kfmt,work7  FORMAT% ?
 1498          BU   svchar
     *
     * Process a format statement
     *
 1503          MCW  branch,crd3sw
 1510          MCW  0&X3,work6
 1517          MCW  kf,work6-3
 1524          MCW  work6,0&X3
 1531          B    svchar
     *
     * Tape block is too big for CHM TAU emulator
     *
     end1      dcw  @}@
               xfr  loadnx         Load this
     part2     ldph ,slash,begin1,,,2.2  Load part2 and start in part 1
               xfr  part2
               org  end1
     *
 1535slash     MCW  kat,char   Convert slash to at-sign
 1542          B    mvchar
     *
     * Not a continuation card
     *
 1546notcnt    MCW  nop,crd1sw
 1553          A    kp1,nstmt
 1560          MCW  nop,crd3sw
 1567          MCW  nop,crd4sw
 1574          MCW  5,211      Move label to print area
 1581          S    cntcnt     Clear continuation count
 1585          MCW  nop,crd2sw
 1592          MCS  nstmt,203  Move statement count to print area
 1599          W
 1600          SW   mvchar&4
 1604          MCW  mvchar&6,mvchr2&6
 1611          CW   mvchar&4
 1615          MCW  move,crd6sw
 1622mvchr2    LCA  gm,0
 1629          SBR  X3         Save address of first char stored
 1633          SBR  mvchar&6
 1637          MCW  colon,card6  Colon after label, if any
 1644          MCW  brnch2,crd5sw
 1651          MCW  k20,colcnt   Initialize column counter
 1658          MCW  save2a,svchar&3
 1665          B    svchar
     *
 1669col3      C    0&X2,kend  END card?
 1676          BU   svchar
 1681          CW   flag
 1685          B    svchar
     *
 1689at        MCW  kminus,char  Convert at sign to minus
 1696          B    mvchar
     *
     * Saw an interesting character
     *
 1700intrst    BCE  testlc,char,    Test for A zone
 1708          BCE  testlc,char,|   Record mark
 1716          BCE  slash,char,/
 1724          BCE  at,char,@
 1732          MCW  kstar,300
 1739          MCW  procd
 1743          MCW  char
 1747          B    mvchar
     *
     * Character is H, probably hollerith
     *
 1751holler    MCW  mvchar&6,X1
 1758          MCW  nop,crd3sw
 1765          MCW  nop,crd4sw
 1772          MCW  branch,crd2sw
 1779          MCW  4&X1,hcount  Remember, source is stored backward
 1786          BCE  at2,hcount-1,@
 1794          BWZ  nzhm1,hcount-1,2
 1802at2       MCW  hcount-2,hcount  One digit of hollerith coiunt
 1809          MCW  kz2
 1813          B    test7
     *
     * No zone at hcount-1
     *
 1817nzhm1     BCE  at3,hcount,@
 1825          BWZ  nzh,hcount,2
 1833at3       MCW  hcount-2,hcount
 1840          MCW  kz1,hcount-2
 1847          B    test7
     *
     * No zone at hcount.  Reverse the digits
     *
 1851nzh       MCW  hcount,workh1
 1858          MCW  hcount-2,hcount
 1865          MCW  workh1,hcount-2
 1872          B    test7
     *
     * Convert address to five digits
     *
               sfx  c
 1876adconv    SBR  exit&3
 1880          S    cnvw2a
 1884          S    cnvw2b
 1888          MZ   toconv,cnvw2a-1
 1895          MZ   toconv-2,cnvw2b-1
 1902loop1     BWZ  loop2,cnvw2b-1,2
 1910          A    cnvka0,cnvw2b
 1917          B    loop1
 1921loop2     BWZ  lp2x,cnvw2a-1,2
 1929          A    cnvkq4,cnvw2a
 1936          B    loop2
 1940lp2x      A    cnvw2b-1,cnvw2a
 1947          MCW  toconv,convtd
 1954          MCW  cnvw2a
 1958          ZA   convtd
 1962          MZ   *-4,convtd  Clear zone in output
 1969exit      B    0-0
               sfx
     *
 1973blnkok    BCE  testlc,char,   Test for A zone
 1981          S    kp1,hcount
 1988          C    hcount,pze  Hollerith count down to zero?
 1995          BU   mvchar      Nope, just move the character
 2000          MCW  move2,crd4sw
 2007          MCW  nop2,crd2sw
 2014          MCW  svchar&3,X1
 2021          C    0&X1,comma
 2028          BE   mvchar
 2033          MCW  mvchar&6,*&7
 2040          MCW  0,0
 2047          MCW  comma
 2051          SBR  mvchar&6
 2055          A    kp1,nchar
 2062          B    bumpns
 2066          B    mvchar
     *
     * Finished reading the source deck
     *
 2070done      MCW  mvchar&6,X1
 2077          LCA  gm,0&X1
 2084          SBR  X1
 2088          CC   1
 2090          CS   332
 2094          CS
 2095          MCS  nchar,205
 2102          MCW  msgchr,222
 2109          W
 2110          CC   J
 2112          MCW  nstmt,nstmts
 2119          LCA  stop,0&X1
 2126          SBR  X1
 2130          SW   2&X1
 2134          A    kp1,nstmts
 2141          BCE  notbig,3000,
 2149          B    bigsrc
 2153notbig    CS   80         Get
 2183          SW   1,40         ready
 2190          SW   47,54          for
 2197          SW   61,68            card
 2204          SW   72                 overlay
 2167          BSS  snapsh,C
 2208          BCE  cards,loadnx,1  Q: Running from cards?
               B    loadnx          No
 2216cards     R
 2217          C    7,scanr2
 2224          BE   loadnx
 2229          B    nosys
     *
     * Source program too big
     *
 2233bigsrc    CS   332
 2237          CS
 2238          CC   1
 2240          MCW  msg2,270
 2247          W
 2248          CC   1
 2250          BCE  halt2,loadnx,1  Running from cards?
 2258          RWD  1             No, rewind the tape
 2263halt2     H    halt2
     *
     * Print listing page heading
     *
 2267prthdg    CC   1
 2269          MCW  kat,c12t&4  Change to BCV
 2276          CS   299
 2280          A    k1,pagnum
 2287          MCS  pagnum,299
 2294          MCW  kpage,295
 2301          MCW  80
 2305          W
 2306          CS   299
 2310          MCW  paghdg,234
 2317          W
 2318          CC   J
 2320          B    afthdg
     *
     * No parameter card
     *
 2324noparm    CC   1
 2326          CS   332
 2330          CS
 2331          MCW  msg3,270
 2338          W
 2339          CC   1
 2341          BCE  halt3,loadnx,1  Running from cards?
 2349          RWD  1             No, rewind the tape
 2354halt3     H    halt3
     *
     * List comment card
     *
 2358lstcmt    MCW  final,203
 2365          MCW  5,211
 2372          W
 2373testlc    BLC  done
 2378          R
 2379          B    rdloop
     *
 2388intchr    DCW  @$@/|  @  Interesting characters
 2423paghdg    DCW  @ SEQ   STMNT      FORTRAN STATEMENT@
     *
     * Card save area
     *
               org  2424  Same as Mokotoff v3m0 line 531
               da   1x78
     save2          2
     card1          6
     card6          11
     card7          12
     card72         77
     azone          78
     *
     * Constants and work areas
     *
 2503colcnt    DCW  #2
 2506card7a    DSA  card7  Address of column 7 in save area
 2509save2a    DSA  save2
 2510k1        dcw  1
 2511brnch2    b        
 2513k20       dc   20
 2520work7     DCW  #7
 2527kfmt      DCW  @%TAMROF@  'FORMAT%' spelled backward
 2528nop2      DC   @N@
 2529gm        DC   @}@
 2533prefix    DCW  @000R@     Default statement prefix -- arithmetic
 2534colon     DCW  @:@
 2536k10       dcw  10
 2537move      dc   @m@
 2548procd     DCW  @ PROCESSED @
 2549nop       NOP
 2554kparam    dcw  @PARAM@
 2557corsiz    DCW  #3         Actual machine size (top addr)
 2560toconv    DCW  #3         Address to be converted to five digits
 2565convtd    DCW  #5         Address converted to five digits
 2566kp1       dcw  &1
 2594stmsg     DCW  @START OF FORTRAN COMPILATION@
 2620spsize    DCW  @MACHINE SIZE SPECIFIED IS @
 2643actsiz    DCW  @ACTUAL MACHINE SIZE IS @
 2648cor5      DCW  #5         CORSIZ as five digits
 2653top5      DCW  #5         TOPCOR as five digits
 2658k3900     DCW  03900
 2676sizerr    DCW  @MACHINE SIZE ERROR@
 2722sgtm      DCW  @SPECIFIED IS GREATER THAN ACTUAL MACHINE SIZE.@
 2743sgtm2     DCW  @ERROR - MACHINE SIZE @
 2746downto    DSA  2999
 2787msg1      DCW  @MESSAGE 1-SYSTEM DOES NOT FOLLOW END CARD@
 2802cntmsg    DCW  @CONTINUE CD ERR@
 2807nchar     DCW  #5         Number of characters
 2810botcor    DSA  3000       Bottom of space to store program
 2811branch    DCW  @B@
 2817work6     DCW  #6
 2818KF        DCW  @F@
 2819kat       dcw  @@@
 2822nstmt     DCW  #3         Number of statements
 2824cntcnt    DCW  #2         Count of continuation cards
 2827kend      dcw  @DNE@      END spelled backward
 2828flag      DCW  #1         Word mark is a flag
 2829kminus    DCW  @-@
 2830kstar     DCW  @*@
 2831char      DCW  #1         Character from input
 2834hcount    DCW  #3         Hollerith count
 2836kz2       DCW  00         Two zeros
 2837kz1       DCW  0   
 2838workh1    DCW  #1         Work space for hollerith count
 2840cnvw2a    DCW  #2         Work space for address conversion
 2842cnvw2b    DCW  #2         Work space for address conversion
 2844cnvka0    dcw  @A0@       Constant for address conversion
 2846cnvkq4    dcw  @?4@       Constant for address conversion
 2849pze       dcw  &000       plus zero
 2850move2     MCW
 2851comma     dcw  @,@
 2867msgchr    DCW  @INPUT CHARACTERS@
 2878stop      DCW  @ }POTS:R000@  STOP spelled backward, etc.
 2892scanr2    dcw  @SCANNER@
 2928msg2      DCW  @MESSAGE 2 - OBJECT PROGRAM TOO LARGE@
 2931pagnum    DCW  #3
 2939kpage     DCW  @   PAGE @
 2968msg3      DCW  @MESSAGE 3 - NO PARAMETER CARD@
 2971final     DCW  #3
               org  2999  Mokotoff v3m0.lst line 606
*2999sysgm     dcw  @}@
               xfr  begin1
     *
     * Scanner needs these to find the end of the program when
     * loading from cards.
     *
     110       dcw  @:@
     110       dcw  @SCANNER@
     *
     * Generate the block to clear phases 1 and 2
     *
     clr12     clra begin1,sysgm
               xfr  clr12
